/* 
   J. Dean Brock, 1998

   Written for UNCA CSCI 343

   Creates a B+-tree with a single root node, but no records.

   Revised 2017 for CSCI 235 example

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "btree.h"

main(int argc, char *argv[])
 {
  int rc ;
  int errflg = 0 ;
  char *filArg = NULL ;
  FILE * dbFile ;
  char usage[]
        = "bcreate file-name\n" ;
  blockRecT block ;

  if (argc != 2 ) {
    (void) fputs(usage, stderr) ;
    exit(1) ;
  }

  filArg = argv[1] ;

  if ((dbFile = fopen(filArg, "w")) == (FILE *)NULL) {
    (void) fprintf(stderr, "Unable to open %s\n", filArg) ;
    perror("fopen") ;
    exit(1) ;
  }

  bzero((void *)&block, sizeof(blockRecT)) ;
  block.head.type    = BLKINTERIOR ;
  block.head.numUsed = 0 ;
  block.head.value   = 0 ;

  if (fwrite((void *)&block, sizeof(blockRecT), 1, dbFile) != 1) {
    (void) fprintf(stderr, "Unable to write %s\n", filArg) ;
    perror("fwrite") ;
    exit(1) ;
  }

  (void) fclose(dbFile) ;
  (void) fprintf(stdout, "%s initialized\n", filArg) ;
 }

