/* 
   J. Dean Brock, 1998

   Written for UNCA CSCI 343

   Prints a B+-tree.

   Used for debugging.

   Revised 2017 for CSCI 235 example
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "btree.h"

main(int argc, char *argv[])
 {
  int rc, i, j ;
  int errflg = 0 ;
  char *filArg = NULL ;
  FILE * dbFile ;
  char usage[] = "bdump file-name\n" ;
  blockRecT block ;

  if (argc != 2) {
    (void) fputs(usage, stderr) ;
    exit(1) ;
  }

  if ((dbFile = fopen(argv[1], "r")) == (FILE *)NULL) {
    (void) fprintf(stderr, "Unable to open %s\n", argv[1]) ;
    perror("fopen") ;
    exit(1) ;
  }

  i = 0 ;
  while (fread((void *)&block, sizeof(blockRecT), 1, dbFile) == 1) {
    if (block.head.type == BLKINTERIOR) {
      (void) fprintf(stdout, "Block%7d (Interior)\n", i) ;
      for (j=0; j<block.head.numUsed; ++j)
	(void) fprintf(stdout, "%10d\n%-12.12s\n",
		       block.data[j].value, block.data[j].name) ;
      (void) fprintf(stdout, "%10d\n", block.head.value) ;
    } else {
      (void) fprintf(stdout, "Block%7d (LEAF-->%7d)\n",
		     i, block.head.value) ;
      for (j=0; j<block.head.numUsed; ++j)
	(void) fprintf(stdout, "  %-12.12s: %10d\n",
		       block.data[j].name, block.data[j].value) ;
    }
    fputc((int) '\n', stdout) ;
    ++i ;
  }


 }


